$regfile = "m8def.dat"
$crystal = 8000000

Config Timer0 = Timer , Prescale = 64
On Timer0 Czas
Config Pinb.0 = Output                                      'Kropka
Config Pinb.1 = Output                                      'Anoda 4
Config Pinb.2 = Output                                      'Anoda 3
Config Pinb.3 = Output                                      'Anoda 2
Config Pinb.4 = Output                                      'Anoda 1
Config Pinb.5 = Output                                      'Segment E
Config Pinc.0 = Output                                      'Segment D
Config Pinc.1 = Output                                      'Segment G
Config Pinc.2 = Output                                      'Segment F
Config Pinc.3 = Input                                       'Przycisk +
Config Pinc.4 = Input                                       'Przycisk OK
Config Pinc.5 = Input                                       'Przycisk -
Config Pind.2 = Output                                      'Buzzer
Config Pind.5 = Output                                      'Segment B
Config Pind.6 = Output                                      'Segment A
Config Pind.7 = Output                                      'Segment C

S3 Alias Pinc.3
S2 Alias Pinc.4
S1 Alias Pinc.5
Pisk Alias Portd.2
A1 Alias Portb.4
A2 Alias Portb.3
A3 Alias Portb.2
A4 Alias Portb.1

Dim A As Byte                                               'Znak na pierwszym wywietlaczu
Dim B As Byte                                               'Znak na drugim wywietlaczu
Dim C As Byte                                               'Znak na trzecim wywietlaczu
Dim D As Byte                                               'Znak na czwartym wywietlaczu
Dim Znak As Byte                                            'Zmienna pomocnicza przy wywietlaniu
Dim Nr As Byte                                              'Obecnie obsugiwany wywietlacz
Dim Minuty As Byte
Dim Sekundy As Byte
Dim Odl_sek As Word                                         'Odliczanie sekundy
Dim Tryb As Byte                                            'Obecny stan ukadu
Dim Zgas As Bit                                             'Czy wyczono wywietlacze podczas odliczania
Dim Tg As Bit                                               'Bit pomocniczy

'Tryb = 0 - ustawianie minut
'Tryb = 1 - ustawianie sekund
'Tryb = 2 - odliczanie
'Tryb = 3 - zakoczono odliczanie - pikanie

Enable Interrupts
Timer0 = 131
Enable Timer0
Odl_sek = 500

Set Portc.3
Set Portc.4
Set Portc.5

Do
If S1 = 0 Then
   Waitms 25
   If S1 = 0 Then
      If Tryb = 0 Then
         Incr Minuty
         If Minuty = 100 Then
            Minuty = 0
         End If
         A = Makebcd(minuty)
         B = A
         B = B And &B00001111
         A = A And &B11110000
         A = A / 16
         Set Tg
         Odl_sek = 500
      Elseif Tryb = 1 Then
         Incr Sekundy
         If Sekundy = 60 Then
            If Minuty > 0 Then
               Sekundy = 0
            Else
               Sekundy = 1
            End If
         End If
         C = Makebcd(sekundy)
         D = C
         D = D And &B00001111
         C = C And &B11110000
         C = C / 16
         Set Tg
         Odl_sek = 500
      Elseif Tryb = 2 Then
         Reset Zgas
         A = Makebcd(minuty)
         B = A
         B = B And &B00001111
         A = A And &B11110000
         A = A / 16
         C = Makebcd(sekundy)
         D = C
         D = D And &B00001111
         C = C And &B11110000
         C = C / 16
      Elseif Tryb = 3 Then
         Tryb = 0
         Reset Pisk
         Reset Tg
         Odl_sek = 500
         A = 10
         B = 10
         C = 0
         D = 0
      End If
      Waitms 75
   End If
End If

If S2 = 0 Then
   Waitms 25
   If S2 = 0 Then
      If Tryb = 0 Then
         Tryb = 1
         Reset Tg
         Odl_sek = 500
         C = 10
         D = 10
         A = Makebcd(minuty)
         B = A
         B = B And &B00001111
         A = A And &B11110000
         A = A / 16
         If Minuty = 0 Then
            Sekundy = 1
         End If
      Elseif Tryb = 1 Then
         Odl_sek = 0
         A = Makebcd(minuty)
         B = A
         B = B And &B00001111
         A = A And &B11110000
         A = A / 16
         C = Makebcd(sekundy)
         D = C
         D = D And &B00001111
         C = C And &B11110000
         C = C / 16
         Tryb = 2
      Elseif Tryb = 2 Then
         If Zgas = 1 Then
            Reset Zgas
         Else
            Minuty = 0
            Sekundy = 0
            A = 10
            B = 10
            C = 0
            D = 0
            Reset Tg
            Tryb = 0
         End If
      Elseif Tryb = 3 Then
         Tryb = 0
         Reset Pisk
         Reset Tg
         Odl_sek = 500
         A = 10
         B = 10
         C = 0
         D = 0
      End If
      Do
      Loop Until S2 = 1
   End If
End If

If S3 = 0 Then
   Waitms 25
   If S3 = 0 Then
      If Tryb = 0 Then
         If Minuty > 0 Then
            Decr Minuty
         Else
            Minuty = 99
         End If
         A = Makebcd(minuty)
         B = A
         B = B And &B00001111
         A = A And &B11110000
         A = A / 16
      Elseif Tryb = 1 Then
         If Minuty = 0 Then
            If Sekundy = 1 Then
               Sekundy = 59
            Else
               Decr Sekundy
            End If
         Else
            If Sekundy = 0 Then
               Sekundy = 59
            Else
               Decr Sekundy
            End If
         End If
         C = Makebcd(sekundy)
         D = C
         D = D And &B00001111
         C = C And &B11110000
         C = C / 16
      Elseif Tryb = 2 Then
         Set Zgas
         A = 10
         B = 10
         C = 10
         D = 10
      Elseif Tryb = 3 Then
        Tryb = 0
         Reset Pisk
         Reset Tg
         Odl_sek = 500
         A = 10
         B = 10
         C = 0
         D = 0
      End If
      Waitms 75
   End If
End If
Loop
End

Czas:
'Multipleksowanie
Incr Nr
Timer0 = 131
If Nr = 1 Then
   Set A1
   Reset A2
   Reset A3
   Reset A4
   Znak = Lookup(a , Kody)
Elseif Nr = 3 Then
   Reset A1
   Set A2
   Reset A3
   Reset A4
   Znak = Lookup(b , Kody)
Elseif Nr = 5 Then
   Reset A1
   Reset A2
   Set A3
   Reset A4
   Znak = Lookup(c , Kody)
Elseif Nr > 6 Then
   Reset A1
   Reset A2
   Reset A3
   Set A4
   Znak = Lookup(d , Kody)
   Nr = 0
End If

Portc.1 = Znak.6
Portc.2 = Znak.5
Portb.5 = Znak.4
Portc.0 = Znak.3
Portd.7 = Znak.2
Portd.5 = Znak.1
Portd.6 = Znak.0
Reset Portb.0

'Odliczanie sekundy
Incr Odl_sek
If Odl_sek = 1000 Then
   Odl_sek = 0
   If Tryb = 0 Then
      Odl_sek = 500
      Toggle Tg
      If Tg = 0 Then
         A = 10
         B = 10
      Else
         A = Makebcd(minuty)
         B = A
         B = B And &B00001111
         A = A And &B11110000
         A = A / 16
      End If
   Elseif Tryb = 1 Then
      Odl_sek = 500
      Toggle Tg
      If Tg = 0 Then
         C = 10
         D = 10
      Else
         C = Makebcd(sekundy)
         D = C
         D = D And &B00001111
         C = C And &B11110000
         C = C / 16
      End If
   Elseif Tryb = 2 Then
      If Minuty > 0 Then
         If Sekundy > 0 Then
            Decr Sekundy
         Else
            Sekundy = 59
            Decr Minuty
         End If
      Else
         Decr Sekundy
         If Sekundy = 0 Then
            Tryb = 3
            Set Pisk
            Set Tg
            Reset Zgas
            A = 0
            B = 0
            C = 0
            D = 0
         End If
      End If

      If Zgas = 0 Then
         A = Makebcd(minuty)
         B = A
         B = B And &B00001111
         A = A And &B11110000
         A = A / 16
         C = Makebcd(sekundy)
         D = C
         D = D And &B00001111
         C = C And &B11110000
         C = C / 16
      End If
   Elseif Tryb = 3 Then
      Odl_sek = 500
      Toggle Tg
      Pisk = Tg
      Portb.0 = Tg
      If Tg = 1 Then
         A = 10
         B = 10
         C = 10
         D = 10
      Else
         A = 0
         B = 0
         C = 0
         D = 0
      End If
   End If
End If

Return

Kody:
Data &B01000000 , &B01111001 , &B00100100 , &B00110000 , &B00011001,
Data &B00010010 , &B00000010 , &B01111000 , &B00000000 , &B00010000 , &B01111111